package com.xy.service;

import com.xy.annotate.RestMappingController;
import com.xy.dto.ExcelDTO;
import com.xy.dto.FileExportDto;
import com.xy.utils.PageBean;
import com.xy.utils.R;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * <p>
 * 文件导出 服务类
 * </p>
 *
 * @author 谭斌
 * @since 2023-03-04
 */
@RestMappingController("/file-export")
public interface FileExportService {


    @PostMapping("obj")
    R<FileExportDto.Vo> obj(@RequestBody FileExportDto.Vo vo);

    @PostMapping("list")
    R<List<FileExportDto.Vo>> list(@RequestBody FileExportDto.SelectList selectList);

    @PostMapping("page")
    R<PageBean<FileExportDto.Vo>> page(@RequestBody FileExportDto.Page page);

    @PostMapping("save")
    R<FileExportDto.Vo> save(@RequestBody @Validated FileExportDto.Save save);

    @PostMapping("update")
    R update(@RequestBody @Validated FileExportDto.Update update);

    @GetMapping("updateExportStatus")
    R<Boolean> updateExportStatus(@RequestParam("id") Long id, @RequestParam("exportStatus") String exportStatus);

    @GetMapping("updateExportStatusUrl")
    R<Boolean> updateExportStatus(@RequestParam("id") Long id, @RequestParam("exportStatus") String exportStatus, @RequestParam("fileUrl") String fileUrl);

    @PostMapping("updateExportStatusUrl")
    <T> void exportExcelAsync(@RequestBody @Validated ExcelDTO<T> excelDTO);
}
